export type Register = "acc" | "op";
export type Value = number;
export type Location = number;

export type Instruction = ({
    type: "push" | "pop",
    register: Register,
} | {
    type: "load",
    register: Register,
    value: Value,
} | {
    type: "add" | "mul" | "sub" | "div",
    left: Register,
    right: Register,
    dest: Register,
} | {
    type: "negate",
    src: Register,
    dest: Register,
} | {
    type: "jump_zero",
    register: Register,
    location: Location,
} | {
    type: "jump",
    location: Location,
}) & ({ jumpedTo: true, label: number } | { jumpedTo?: false });
