
export type ExprType = Expr["exprType"]

export type Expr = {
  exprType: "int",
  value: number,
} | {
  exprType: "unary",
  unaryType: "plus" | "negate",
  subject: Expr,
} | {
  exprType: "binary",
  binaryType: "add" | "subtract" | "multiply" | "divide",
  left: Expr,
  right: Expr,
} | {
  exprType: "if",
  condition: Expr,
  truthy: Expr,
  falsy: Expr,
} | {
  exprType: "block",
  expr: Expr,
};



