import { Grammar, Parser } from "nearley";
import { Err, Ok, Result } from "ts-results";
import compiledGrammar from "./grammar.out"
import { Expr } from "./parsed";

export function parse(text: string): Result<Expr, string> {
    const parser = new Parser(Grammar.fromCompiled(compiledGrammar));
    try {
        parser.feed(text);
    } catch (parseError) {
        console.log(parseError)
    }
    const result = parser.results?.at(0);
    if (!result)
        return Err("failed to parse");
    if (parser.results.length > 1)
        return Err("ambigous parse result");
    return Ok(result);
}

